package io.gitlab.jfronny.respackopts.integration;

import dev.notalpha.dashloader.client.DashLoaderClient;
import io.gitlab.jfronny.respackopts.Respackopts;
import io.gitlab.jfronny.respackopts.RespackoptsConfig;
import net.fabricmc.loader.api.FabricLoader;

public class DashLoaderCompat {
    public static void requestForceReload() {
        if (!FabricLoader.getInstance().isModLoaded("dashloader"))
            return;
        if (!RespackoptsConfig.dashloaderCompat)
            return;
        try {
            if (RespackoptsConfig.debugLogs)
                Respackopts.LOGGER.info("Removing DashCache to force dashloader to reload");

            DashLoaderClient.CACHE.remove();
            DashLoaderClient.NEEDS_RELOAD = true;
        } catch (Throwable e) {
            Respackopts.LOGGER.error("Failed to remove dashloader data, try disabling dashloaderCompat if this keeps happening", e);
        }
    }
}
