package io.gitlab.jfronny.respackopts.gson.entry;

import io.gitlab.jfronny.gson.*;
import io.gitlab.jfronny.respackopts.model.tree.ConfigBooleanEntry;

import java.lang.reflect.Type;

public class BooleanEntrySerializer implements JsonSerializer<ConfigBooleanEntry>, JsonDeserializer<ConfigBooleanEntry> {
    @Override
    public ConfigBooleanEntry deserialize(JsonElement json, Type typeOfT, JsonDeserializationContext context) throws JsonParseException {
        if (json.isJsonPrimitive()) return new ConfigBooleanEntry(json.getAsBoolean());
        else if (json.isJsonObject()) {
            JsonObject o = json.getAsJsonObject();
            if (o.has("default"))
                return new ConfigBooleanEntry(o.get("default").getAsBoolean());
            else
                throw new JsonSyntaxException("Default value for boolean entry must be a boolean");
        }
        else throw new JsonSyntaxException("Invalid type for boolean entry");
    }

    @Override
    public JsonElement serialize(ConfigBooleanEntry src, Type typeOfSrc, JsonSerializationContext context) {
        return new JsonPrimitive(src.getValue());
    }
}
