package io.gitlab.jfronny.respackopts.model.cache;

import io.gitlab.jfronny.muscript.data.Scope;
import io.gitlab.jfronny.respackopts.Respackopts;
import io.gitlab.jfronny.respackopts.model.*;
import io.gitlab.jfronny.respackopts.model.tree.ConfigBranch;

import java.util.*;

public record CachedPackState(
        String packId,
        String displayName,
        String packName,
        ConfigBranch configBranch,
        PackMeta metadata,
        Map<String, FileRpo> cachedFileRPOs,
        Map<String, List<DirRpo>> cachedDirRPOs, // Directory RPOs, from outermost to innermost
        Scope executionScope
) {
    public CachedPackState(CacheKey key, PackMeta meta, ConfigBranch branch) {
        this(
                meta.id,
                key.displayName(),
                key.packName(),
                branch,
                meta,
                new HashMap<>(),
                new HashMap<>(),
                branch.addTo(Respackopts.ROOT_SCOPE.fork())
        );
    }
}
